#include <bits/stdc++.h>

using namespace std;

#define int long long
#define F first
#define S second
#define all(x) x.begin(), x.end()

const int N = 2e5;

int now = 0, col = 0, z = 0;
vector<set<int>> g(N);
vector<int> used(N), dist(N);

void dfs(int v){
    used[v] = 1;
    for(auto i : g[v]){
        if(!used[i]){
            dfs(i);
            dist[v] = max(dist[v], dist[i] + 1);
        }
    }
    if(v == z)
        return;
    if(dist[v] == now - 1 && !g[v].count(z)){
        dist[v] = -1;
        col ++;
    }
}

signed main() {
    int n, k, t;
    cin >> n >> k >> t;
    for(int i = 0; i < n - 1; i ++){
        int x, y;
        cin >> x >> y;
        g[x - 1].insert(y - 1);
        g[y - 1].insert(x - 1);
    }
    vector<int> zap;
    if(t == 0){
        zap.push_back(0);
    }else{
        for(int i = 0; i < n; i ++){
            zap.push_back(i);
        }
    }
    for(auto i : zap){
        if(k >= n - 1 - g[i].size()){
            cout << 1 << " ";
            continue;
        }
        z = i;
        int l = 1, r = N;
        while(l + 1 < r){
            now = (l + r) / 2;
            dfs(i);
            if(col <= k){
                r = now;
            }else{
                l = now;
            }
            used.clear();
            used.resize(N);
            dist.clear();
            dist.resize(N);
            col = 0;
        }
        cout << r << " ";
    }
}
